﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine.UI;
using UnityEngine;

public class PlayerMovement : MonoBehaviour {

    [SerializeField]
    private float player_speed = 4;
    [SerializeField]
    private float player_jumpHeight = 6.5f;
    
    private Animator anim;
    private Canvas canv;

    public Transform groundCheck;
    public float groundCheckRadius;
    public LayerMask whatIsGround;
    private bool grounded = false;

    private float player_vel;
    private Rigidbody2D player;
    
    private float player_Vvel;
    public bool onLadder;
    private float gravityStore;
    public bool mounted;

    public bool onCrack;
    public string crackType;
    Image im;

    // Use this for initialization
    void Start ()
    {
        player = GetComponent<Rigidbody2D>();
        gravityStore = player.gravityScale;
        anim = GetComponent<Animator>();
        im = GameObject.FindGameObjectWithTag("Integrity").GetComponent<Image>();
    }

    public static void Quit()
    {
        Application.Quit();
    }

    // Update is called once per frame
    void Update ()
    {
        player_vel = player_speed * Input.GetAxisRaw("Horizontal");
        player.velocity = new Vector3(player_vel, player.velocity.y);
        
        grounded = Physics2D.OverlapCircle(groundCheck.position, groundCheckRadius, whatIsGround);
        anim.SetBool("Ground", grounded);
        if (Input.GetKeyDown(KeyCode.Space) && grounded)
        {
            player.velocity = new Vector3(player.velocity.x, player_jumpHeight);
        }
        
        if (onLadder && Input.GetButtonDown("Vertical"))
        {
            mounted = true;
        }
        if (onLadder && mounted)
        {
            player.gravityScale = 0;
            player_Vvel = player_speed * Input.GetAxisRaw("Vertical");
            player.velocity = new Vector3(player.velocity.x, player_Vvel);
        }
        else if (!onLadder)
        {
            mounted = false;
            player.gravityScale = gravityStore;
        }

        if (onCrack && Input.GetKeyDown(KeyCode.R))
        {
            if (crackType == "SafeCrack")
            {
                PlayerMovement.Quit();
            } else if (crackType == "DamageCrack")
            {
                im.fillAmount = im.fillAmount - 0.25f;
                if (im.fillAmount == 0)
                {
                    PlayerMovement.Quit();
                }
            } else if (crackType == "TreasureCrack")
            {
                Debug.Log("Treasure");
            }
        }
    }
}
